/** FONTED04.C ******************************************
 *							*
 *	(c) Perlin Production Co.Ltd. June 1993		*
 *		Bold BIOS Font Editor			*
 *							*
 * Abstract:	character selection by ASCII code	*
 * Revisions:						*
 * Mar 2023	adaptation overhaul to WIOS 5.0		*
 ********************************************************/
#include "fonted.h"
#include "conio.h"

selchar()
{
	register WINDOW	*this;
	int		idx_old;
	char		text[MAXX],key;

	this = window("Select character to edit",DESKTOP,10,15,69,3,BR_DD);
	sw_color (this,WN_NC,COLOR_1);
	sw_margin(this,1,0);
	hd_csr	();
	wn_set	(this);
	wn_goto	(this,7,key = 0);
	
	sprintf	(text
		,"[Arrows] prev/next character   [%s] select   [%s] cancel"
		, keynam(ENTER),keynam(ESC)
		);
	wn_sput	(this,text);
	idx_old	= idx_chr;
	do
	{	switch key
		{
			case LEFT:
			case UP:
			case PGUP:
				if (--idx_chr < 0) idx_chr = NUM_CHARS-1;
				break;
			case RIGHT:
			case DOWN:
			case PGDN:
				if (++idx_chr==NUM_CHARS) idx_chr=0;
				break;
		}
		/* yes, you bet, it was in a function B4 */
		wn_home	(this);
		wn_hiclr(this, 0);
		putch	(key = idx_chr+FIRST_CHAR);
		putc_n	(BLANK, 5);
		wn_goto	(this, (key < 100) ? 3:2,0);
		wn_hiclr(this, 1);
		putdec	(key);
		wn_hiclr(this, 0);
	}
	while ((key=getkey()) != ENTER && (key != ESC))
	
	wn_hide	  (this);
	wn_destroy(this);

	if (key == ENTER) bm_load(); else idx_chr=idx_old;
	sh_csr();
}
